blob: 406fa237d89b5ba43bb33934aca819bb5e17a629 [file] [log] [blame]
Petr Michalec1ed1b3c2017-08-08 19:19:01 +02001#!/bin/bash -e
2
3# bootstrap.sh
4
5# Installs Salt and configure minimal SaltMaster or Minion to be used with:
6# - http://github.com/salt-formulas-scripts
7# - http://github.com/salt-formulas/salt-formula-salt (salt.master sls)
8
9# TODO:
10# - use PPA repository as formula source
11# - support for spm/yum
12
13
14# Source specific env vars.
15# shopt -u dotglob
16export RECLASS_ROOT=${RECLASS_ROOT:-/srv/salt/reclass}
17function source_local_envs() {
Petr Michalecb444ef92017-08-17 13:53:14 +020018 for path in / /tmp/kitchen /srv/salt . ${RECLASS_ROOT}/classes/cluster ${RECLASS_ROOT}/classes/cluster/${CLUSTER_NAME}; do
Vasyl Saienko7a4161c2017-08-14 17:43:15 +030019 for f in $(find $path -maxdepth 1 -name '*.env' 2> /dev/null); do
20 echo "Sourcing env variables from $f"
21 source $f
22 done
23 done
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020024}
25source_local_envs
26
27##########################################
28# Set defaults env variables
29
30if [[ $DEBUG =~ ^(True|true|1|yes)$ ]]; then
31 set -x
32 SALT_LOG_LEVEL="--state-verbose=true -ldebug"
33fi
34
35export MAGENTA='\033[0;95m'
36export YELLOW='\033[1;33m'
37export BLUE='\033[0;35m'
38export CYAN='\033[0;96m'
39export RED='\033[0;31m'
40export NC='\033[0m' # No Color'
41
42export LC_ALL=C
43export SALT_LOG_LEVEL="--state-verbose=false -lerror"
44export SALT_OPTS="${SALT_OPTS:- --timeout=120 --state-output=changes --retcode-passthrough --force-color $SALT_LOG_LEVEL }"
45export SALT_STATE_RETRY=${SALT_STATE_RETRY:-3}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020046
47
48# salt apt repository
49test -e /etc/lsb-release && eval $(cat /etc/lsb-release)
50which lsb_release && DISTRIB_CODENAME=${DISTRIB_CODENAME:-$(lsb_release -cs)}
51#
Dmitry Ukov95492a02017-10-23 11:34:45 +040052export APT_REPOSITORY=${APT_REPOSITORY:- deb [arch=amd64] http://apt.mirantis.com/${DISTRIB_CODENAME} ${DISTRIB_REVISION:-stable} salt}
chnyda30c07a62017-09-20 14:28:02 +020053export APT_REPOSITORY_GPG=${APT_REPOSITORY_GPG:-http://apt.mirantis.com/public.gpg}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020054
55# reclass
56export RECLASS_ADDRESS=${RECLASS_ADDRESS:-https://github.com/salt-formulas/openstack-salt.git} # https/git
57
58# formula
59export FORMULAS_BASE=${FORMULAS_BASE:-https://github.com/salt-formulas}
60export FORMULAS_PATH=${FORMULAS_PATH:-/usr/share/salt-formulas}
61export FORMULAS_BRANCH=${FORMULAS_BRANCH:-master}
62export FORMULAS_SOURCE=${FORMULAS_SOURCE:-pkg} # pkg/git
63# essential set of formulas (known to by used on cfg01 node for most setups)
Petr Ruzicka5ae64262017-10-13 14:29:52 +020064FORMULAS_SALT_MASTER=${FORMULAS_SALT_MASTER:- $EXTRA_FORMULAS maas memcached openssh ntp nginx collectd sensu heka sphinx mysql grafana libvirt rsyslog glusterfs postfix xtrabackup freeipa prometheus telegraf elasticsearch kibana rundeck devops-portal rsync docker keepalived aptly jenkins gerrit artifactory influxdb horizon}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020065# minimal set of formulas for salt-master bootstrap
66declare -a FORMULAS_SALT_MASTER=(linux reclass salt git $(echo $FORMULAS_SALT_MASTER))
67export FORMULAS_SALT_MASTER
68
69# system / host
Petr Michalecc749e862017-09-06 21:10:10 +020070export HOSTNAME=${HOSTNAME:-`hostname -s`}
71export HOSTNAME=${HOSTNAME//.*/}
72export DOMAIN=${DOMAIN:-`hostname -d`}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020073export DOMAIN=${DOMAIN:-bootstrap.local}
74
75# salt
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020076export MINION_ID=${MINION_ID:-${HOSTNAME}.${DOMAIN}}
Petr Michalec2e3a4992017-08-17 14:20:43 +020077export MASTER_HOSTNAME=${MASTER_HOSTNAME:-${HOSTNAME}.${DOMAIN}}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020078
79# saltstack
Petr Michalec33c04892017-09-08 15:10:30 +020080BOOTSTRAP_SALTSTACK=${BOOTSTRAP_SALTSTACK:-True}
Petr Michalece11cf612017-09-08 18:21:48 +020081BOOTSTRAP_SALTSTACK_VERSION=${BOOTSTRAP_SALTSTACK_VERSION:- stable 2016.3 }
Petr Michalec33c04892017-09-08 15:10:30 +020082BOOTSTRAP_SALTSTACK_OPTS=${BOOTSTRAP_SALTSTACK_OPTS:- -dX $BOOTSTRAP_SALTSTACK_VERSION }
Petr Michalece11cf612017-09-08 18:21:48 +020083SALT_SOURCE=${SALT_SOURCE:-pkg}
84# the version below is used salt pillar data
85SALT_VERSION=${SALT_VERSION:-latest}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020086
87# environment
88if [ "$FORMULAS_SOURCE" == "git" ]; then
89 SALT_ENV=${SALT_ENV:-dev}
90elif [ "$FORMULAS_SOURCE" == "pkg" ]; then
91 SALT_ENV=${SALT_ENV:-prd}
92fi
Petr Michalec05b52452017-09-08 14:26:59 +020093eval "$(grep -h '=' /etc/*release 2> /dev/null)"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020094PLATFORM_FAMILY=$(echo ${ID_LIKE// */} | tr A-Z a-z)
95case $PLATFORM_FAMILY in
96 debian )
97 PKGTOOL="$SUDO apt-get"
98 test ${VERSION_ID//\.*/} -ge 16 && {
99 SVCTOOL=service
100 } || { SVCTOOL=service
101 }
102 ;;
103 rhel )
104 PKGTOOL="$SUDO yum"
105 test ${VERSION_ID//\.*/} -ge 7 && {
106 SVCTOOL=systemctl
107 } || { SVCTOOL=service
108 }
109 ;;
110esac
111
112export PLATFORM_FAMILY
113export PKGTOOL
114export SVCTOOL
115
116##########################################
117# FUNCTIONS
118
119log_info() {
120 echo -e "${YELLOW}[INFO] $* ${NC}"
121}
122
123log_warn() {
124 echo -e "${MAGENTA}[WARN] $* ${NC}"
125}
126
Petr Michalec24b30e82017-08-21 10:59:18 +0200127log_debug() {
128 echo -e "${CYAN}[WARN] $* ${NC}"
129}
130
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200131log_err() {
132 echo -e "${RED}[ERROR] $* ${NC}" >&2
133}
134
135configure_pkg_repo()
136{
137
138 case $PLATFORM_FAMILY in
139 debian)
140 if [ -n "$APT_REPOSITORY_PPA" ]; then
141 which add-apt-repository || $SUDO apt-get install -y software-properties-common
142 $SUDO add-apt-repository -y ppa:${APT_REPOSITORY_PPA}
143 else
Mykyta Karpinfbcb5482017-10-04 14:15:25 +0300144 echo -e "$APT_REPOSITORY " | $SUDO tee /etc/apt/sources.list.d/mcp_salt.list >/dev/null
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200145 curl -sL $APT_REPOSITORY_GPG | $SUDO apt-key add -
146 fi
147 $SUDO apt-get clean
148 $SUDO apt-get update
149 ;;
150 rhel)
151 $SUDO yum install -y https://repo.saltstack.com/yum/redhat/salt-repo-latest-1.el${VERSION_ID}.noarch.rpm
152 $SUDO yum clean all
153 ;;
154 esac
155
156}
157
158_atexit() {
159 RETVAL=$?
160 trap true INT TERM EXIT
161
162 if [ $RETVAL -ne 0 ]; then
163 log_err "Execution failed"
164 else
165 log_info "Execution successful"
166 fi
167 return $RETVAL
168}
169
170retry() {
171 local tries
172 if [[ $1 =~ ^[0-9]+$ ]]; then
173 tries=$1; shift
174 else
175 tries=3
176 fi
Petr Michalec262e3ad2017-10-06 13:41:58 +0200177 ret=1
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200178 for i in $(seq 1 $tries); do
Petr Michalec262e3ad2017-10-06 13:41:58 +0200179 "$@" && return $? || ret=$?
180 sleep $i
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200181 done
Petr Michalec9fec8b32017-10-05 14:46:42 +0200182 return $ret
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200183}
184
185function clone_reclass() {
Petr Michaleca361d4e2017-09-08 11:38:16 +0200186 if [ ! -d ${RECLASS_ROOT}/classes ]; then
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200187 # No reclass at all, clone from given address
188 ssh-keyscan -H github.com >> ~/.ssh/known_hosts || true
189 if echo ${RECLASS_BRANCH:-master} | egrep -q "^refs"; then
190 git clone ${RECLASS_ADDRESS} ${RECLASS_ROOT}
191 cd ${RECLASS_ROOT}
192 git fetch ${RECLASS_ADDRESS} ${RECLASS_BRANCH:-master} && git checkout FETCH_HEAD
193 cd -
194 else
195 git clone -b ${RECLASS_BRANCH:-master} ${RECLASS_ADDRESS} ${RECLASS_ROOT};
196 fi;
197 fi;
Petr Michalec679f15b2017-09-18 16:16:29 +0200198 if [ ! -d ${RECLASS_ROOT}/classes ]; then
Petr Michaleca361d4e2017-09-08 11:38:16 +0200199 log_err "Reclass ${RECLASS_ROOT} is not fetched locally;"
200 ls -Rla ${RECLASS_ROOT}
201 exit 1
202 fi;
203 $SUDO mkdir -p $RECLASS_ROOT/classes/service
204 $SUDO mkdir -p $RECLASS_ROOT/nodes/_generated
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200205}
206
207
208##########################################
209# Main calls
210
Petr Michalecda014202017-08-18 11:26:07 +0200211system_config_ssh_conf() {
212 for conf in ~/.ssh/config /root/.ssh/config; do
213 $SUDO mkdir -p $(dirname $conf)
214 if ! grep StrictHostKeyChecking $conf; then
215 # this should be used only in CI environment
216 echo -e "Host *\n\tStrictHostKeyChecking no\n" | $SUDO tee $conf >/dev/null
217 fi
218 done
219 if ! grep github.com ~/.ssh/known_hosts; then
220 ssh-keyscan -H github.com >> ~/.ssh/known_hosts || true
221 fi
222}
223
224system_config_salt_modules_prereq() {
225 # salt-formulas custom modules dependencies, etc:
226 $SUDO $PKGTOOL install -y iproute2 curl sudo apt-transport-https python-psutil python-apt python-m2crypto python-oauth python-pip &>/dev/null
227}
228
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200229system_config_minion() {
230 log_info "System configuration salt minion"
231}
232
233system_config_master() {
234 log_info "System configuration salt master"
235
Petr Michalecda014202017-08-18 11:26:07 +0200236 system_config_salt_modules_prereq
237 system_config_ssh_conf
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200238
Petr Michalecda014202017-08-18 11:26:07 +0200239 if ! grep '127.0.1.2.*salt' /etc/hosts; then
240 echo "127.0.1.2 salt" | $SUDO tee -a /etc/hosts >/dev/null
241 fi
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200242
243 which reclass || $SUDO $PKGTOOL install -y reclass
244
245 which reclass-salt || {
246 test -e /usr/share/reclass/reclass-salt && {
247 ln -fs /usr/share/reclass/reclass-salt /usr/bin
248 }
249 }
250}
251
252configure_salt_master()
253{
254
255 echo "Configuring salt-master ..."
256
Petr Michalec4be5e5b2017-08-17 11:44:49 +0200257 if [[ $RECLASS_IGNORE_CLASS_NOTFOUND =~ ^(True|true|1|yes)$ ]]; then
Petr Michalec2801acb2017-10-31 15:00:15 +0100258 IGNORE_CLASS_NOTFOUND="ignore_class_notfound: True\n ignore_class_regexp:\n - 'service.*'"
Petr Michalec4be5e5b2017-08-17 11:44:49 +0200259 fi
260
Petr Michalecdd1a0472017-09-06 19:27:24 +0200261 # to force alternative reclass module path
Petr Michalecd9d0a322017-09-06 19:38:32 +0200262 if [ -n "$RECLASS_SOURCE_PATH" ]; then
263 RECLASS_SOURCE_PATH="reclass_source_path: ${RECLASS_SOURCE_PATH}"
264 else
265 RECLASS_SOURCE_PATH=""
266 fi
Petr Michalecdd1a0472017-09-06 19:27:24 +0200267
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200268 [ ! -d /etc/salt/master.d ] && mkdir -p /etc/salt/master.d
269 cat <<-EOF > /etc/salt/master.d/master.conf
270 file_roots:
271 base:
272 - /usr/share/salt-formulas/env
273 prd:
274 - /srv/salt/env/prd
275 dev:
276 - /srv/salt/env/dev
277 pillar_opts: False
278 open_mode: True
279 reclass: &reclass
280 storage_type: yaml_fs
281 inventory_base_uri: ${RECLASS_ROOT}
Petr Michalec4be5e5b2017-08-17 11:44:49 +0200282 ${IGNORE_CLASS_NOTFOUND}
Petr Michalecdd1a0472017-09-06 19:27:24 +0200283 ${RECLASS_SOURCE_PATH}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200284 ext_pillar:
285 - reclass: *reclass
286 master_tops:
287 reclass: *reclass
288EOF
289
290 echo "Configuring reclass ..."
291
292 [ ! -d /etc/reclass ] && mkdir /etc/reclass
293 cat <<-EOF > /etc/reclass/reclass-config.yml
294 storage_type: yaml_fs
295 pretty_print: True
296 output: yaml
297 inventory_base_uri: ${RECLASS_ROOT}
Petr Michalec4be5e5b2017-08-17 11:44:49 +0200298 ${IGNORE_CLASS_NOTFOUND}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200299EOF
300
301 clone_reclass
302 # override some envs from cluster level *.env, use with care
303 source_local_envs
304
305 cd ${RECLASS_ROOT}
306 if [ ! -d ${RECLASS_ROOT}/classes/system/linux ]; then
307 # Possibly subrepo checkout needed
308 git submodule update --init --recursive
309 fi
310
Petr Michalec212cc6a2017-08-17 21:39:40 +0200311 mkdir -vp ${RECLASS_ROOT}/nodes/_generated
Petr Michalec51ece842017-09-06 20:44:15 +0200312 rm -rvf ${RECLASS_ROOT}/nodes/_generated/*
313
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200314 CONFIG=$(find ${RECLASS_ROOT}/nodes -name ${MINION_ID}.yml| grep yml | tail -n1)
Petr Michalec212cc6a2017-08-17 21:39:40 +0200315 CONFIG=${CONFIG:-${RECLASS_ROOT}/nodes/_generated/${MINION_ID}.yml}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200316 if [[ $SALT_MASTER_BOOTSTRAP_MINIMIZED =~ ^(True|true|1|yes)$ || ! -f "${CONFIG}" ]]; then
Petr Michalec24b30e82017-08-21 10:59:18 +0200317 log_warn "Salt Master node specification has not been found in model."
318 log_warn "Creating temporary cfg01 configuration for bootstrap: ${CONFIG}"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200319 cat <<-EOF > ${CONFIG}
320 classes:
Petr Michalecd81d1f52017-08-17 20:18:06 +0200321 - cluster.${CLUSTER_NAME}.infra.config
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200322 parameters:
323 _param:
Petr Michaleca7de6df2017-08-31 12:16:57 +0200324 salt_master_host: ${MASTER_IP:-$MASTER_HOSTNAME}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200325 salt_master_base_environment: $SALT_ENV
Petr Michalecd81d1f52017-08-17 20:18:06 +0200326 salt_formula_branch: ${SALT_FORMULAS_BRANCH:-master}
327 reclass_data_revision: ${RECLASS_BRANCH:-master}
328 reclass_data_repository: "$RECLASS_ADDRESS"
Petr Michaleca7de6df2017-08-31 12:16:57 +0200329 reclass_config_master: ${MASTER_IP:-$MASTER_HOSTNAME}
Petr Michalecd81d1f52017-08-17 20:18:06 +0200330 linux_system_codename: ${DISTRIB_CODENAME}
331 cluster_name: ${CLUSTER_NAME}
332 cluster_domain: ${DOMAIN:-$CLUSTER_NAME.local}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200333 linux:
334 system:
Petr Michalecd81d1f52017-08-17 20:18:06 +0200335 name: ${HOSTNAME:-cfg01}
336 domain: ${DOMAIN:-$CLUSTER_NAME.local}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200337 # ########
338EOF
339
340 if [ "$SALT_VERSION" == "latest" ]; then
341 VERSION=""
342 else
343 VERSION="version: $SALT_VERSION"
344 fi
345
346 cat <<-EOF >> ${CONFIG}
347 salt:
348 master:
349 accept_policy: open_mode
350 source:
351 engine: $SALT_SOURCE
352 $VERSION
353 minion:
354 source:
355 engine: $SALT_SOURCE
356 $VERSION
357 # ########
358 # vim: ft=yaml sw=2 ts=2 sts=2
359EOF
360 fi
Petr Michalec24b30e82017-08-21 10:59:18 +0200361
362 log_debug "Salt Master node config yaml:"
363 log_debug "$(cat ${CONFIG})"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200364}
365
366configure_salt_minion()
367{
368 [ ! -d /etc/salt/minion.d ] && mkdir -p /etc/salt/minion.d
369 cat <<-EOF > /etc/salt/minion.d/minion.conf
Petr Michaleca7de6df2017-08-31 12:16:57 +0200370 master: ${MASTER_IP:-$MASTER_HOSTNAME}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200371 id: $MINION_ID
372 EOF
373}
374
Petr Michaleca6cd2bd2017-09-07 16:59:19 +0200375install_reclass()
376{
377 VERSION=${1:-$RECLASS_VERSION}
378 VERSION=${VERSION:-master}
379 # tries to replace all local version system version
380 for s in $(python -c "import site; print(' '.join(site.getsitepackages()))"); do
Petr Michaleca2f351c2017-09-07 17:37:44 +0200381 sudo -H pip install --upgrade --force-reinstall -I \
Petr Michaleca6cd2bd2017-09-07 16:59:19 +0200382 -t "$s" git+https://github.com/salt-formulas/reclass.git@${VERSION};
383 done
384}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200385
386install_salt_master_pkg()
387{
388 echo -e "\nPreparing base OS repository ...\n"
389
390 configure_pkg_repo
391
392 echo -e "\nInstalling salt master ...\n"
393
394 case $PLATFORM_FAMILY in
395 debian)
396 $SUDO apt-get install -y git
397 which reclass || $SUDO apt install -qqq -y reclass
398 curl -L https://bootstrap.saltstack.com | $SUDO sh -s -- -M ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
399 ;;
400 rhel)
401 yum install -y git
402 which reclass || $SUDO yum install -y reclass
403 curl -L https://bootstrap.saltstack.com | $SUDO sh -s -- -M ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
404 ;;
405 esac
406
407 which reclass-salt || {
408 test -e /usr/share/reclass/reclass-salt && {
409 ln -fs /usr/share/reclass/reclass-salt /usr/bin
410 }
411 }
412
413 configure_salt_master
414
415 echo -e "\nRestarting services ...\n"
416 [ -f /etc/salt/pki/minion/minion_master.pub ] && rm -f /etc/salt/pki/minion/minion_master.pub
417 $SVCTOOL salt-master restart
418}
419
420install_salt_master_pip()
421{
422 echo -e "\nPreparing base OS repository ...\n"
423
424 case $PLATFORM_FAMILY in
425 debian)
426 $SUDO apt-get install -y python-pip python-dev zlib1g-dev git
427 which reclass || $SUDO apt-get install -y reclass
428 ;;
429 rhel)
430 $SUDO yum install -y git
431 which reclass || $SUDO yum install -y reclass
432 ;;
433 esac
434
435 echo -e "\nInstalling salt master ...\n"
436 # TODO: replace with saltstack bootstrap script
437
438 if [ "$SALT_VERSION" == "latest" ]; then
439 pip install salt
440 else
441 pip install salt==$SALT_VERSION
442 fi
443
444 curl -Lo /etc/init.d/salt-master https://anonscm.debian.org/cgit/pkg-salt/salt.git/plain/debian/salt-master.init && chmod 755 /etc/init.d/salt-master
445 ln -s /usr/local/bin/salt-master /usr/bin/salt-master
446
447 which reclass-salt || {
448 test -e /usr/share/reclass/reclass-salt && {
449 ln -fs /usr/share/reclass/reclass-salt /usr/bin
450 }
451 }
452
453 configure_salt_master
454
455 echo -e "\nRestarting services ...\n"
456 [ -f /etc/salt/pki/minion/minion_master.pub ] && rm -f /etc/salt/pki/minion/minion_master.pub
457 $SVCTOOL salt-master restart
458}
459
460
461
462install_salt_minion_pkg()
463{
464
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200465 echo -e "\nInstalling salt minion ...\n"
466
467 case $PLATFORM_FAMILY in
468 debian)
469 curl -L https://bootstrap.saltstack.com | $SUDO sh -s -- ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
470 ;;
471 rhel)
472 curl -L https://bootstrap.saltstack.com | $SUDO sh -s -- ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
473 ;;
474 esac
475
476
477 configure_salt_minion
Petr Michalec3b7fdd82017-09-08 15:35:56 +0200478 #$SVCTOOL salt-minion restart
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200479}
480
481install_salt_minion_pip()
482{
483 echo -e "\nInstalling salt minion ...\n"
484
485 curl -Lo /etc/init.d/salt-minion https://anonscm.debian.org/cgit/pkg-salt/salt.git/plain/debian/salt-minion.init && chmod 755 /etc/init.d/salt-minion
486 ln -s /usr/local/bin/salt-minion /usr/bin/salt-minion
487
488 configure_salt_minion
Petr Michalec3b7fdd82017-09-08 15:35:56 +0200489 #$SVCTOOL salt-minion restart
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200490}
491
492
493install_salt_formula_pkg()
494{
495 configure_pkg_repo
496
497 case $PLATFORM_FAMILY in
498 debian)
499 echo "Configuring necessary formulas ..."
500
501 [ ! -d ${RECLASS_ROOT}/classes/service ] && mkdir -p ${RECLASS_ROOT}/classes/service
502 # Set essentials if FORMULAS_SALT_MASTER is not defined at all
503 [ -z ${FORMULAS_SALT_MASTER+x} ] && declare -a FORMULAS_SALT_MASTER=("linux" "reclass" "salt" "memcached")
504 for formula_service in "${FORMULAS_SALT_MASTER[@]}"; do
505 echo -e "\nConfiguring salt formula ${formula_service} ...\n"
506 [ ! -d "${FORMULAS_PATH}/env/${formula_service}" ] && \
507 if ! $SUDO apt-get install -y salt-formula-${formula_service}; then
508 echo -e "\nInstall salt-formula-${formula_service} failed.\n"
509 exit 1
510 fi
511 [ ! -L "${RECLASS_ROOT}/classes/service/${formula_service}" ] && \
512 ln -sf ${FORMULAS_PATH}/reclass/service/${formula_service} ${RECLASS_ROOT}/classes/service/${formula_service}
513 done
514 ;;
515 rhel)
516 # TODO
517 ;;
518 esac
519
520 [ ! -d /srv/salt/env ] && mkdir -p /srv/salt/env || echo ""
521 [ ! -L /srv/salt/env/prd ] && ln -s ${FORMULAS_PATH}/env /srv/salt/env/prd || echo ""
522}
523
524install_salt_formula_git()
525{
526 echo "Configuring necessary formulas ..."
527
528 [ ! -d ${RECLASS_ROOT}/classes/service ] && mkdir -p ${RECLASS_ROOT}/classes/service
529 # Set essentials if FORMULAS_SALT_MASTER is not defined at all
530 [ -z ${FORMULAS_SALT_MASTER+x} ] && declare -a FORMULAS_SALT_MASTER=("linux" "reclass" "salt" "memcached")
531 for formula_service in "${FORMULAS_SALT_MASTER[@]}"; do
532 echo -e "\nConfiguring salt formula ${formula_service} ...\n"
533 _BRANCH=${FORMULAS_BRANCH}
534 [ ! -d "${FORMULAS_PATH}/env/_formulas/${formula_service}" ] && {
535 if ! git ls-remote --exit-code --heads ${FORMULAS_BASE}/salt-formula-${formula_service}.git ${_BRANCH}; then
536 # Fallback to the master branch if the branch doesn't exist for this repository
537 _BRANCH=master
538 fi
539 if ! git clone ${FORMULAS_BASE}/salt-formula-${formula_service}.git ${FORMULAS_PATH}/env/_formulas/${formula_service} -b ${_BRANCH}; then
540 echo -e "\nCloning of ${FORMULAS_BASE}/salt-formula-${formula_service}.git failed.\n"
541 exit 1
542 fi
543 } || {
544 cd ${FORMULAS_PATH}/env/_formulas/${formula_service};
545 git fetch origin/${_BRANCH} || git fetch --all
546 git checkout ${_BRANCH} && git pull || git pull;
547 cd -
548 }
549 [ ! -L "/usr/share/salt-formulas/env/${formula_service}" ] && \
550 ln -sf ${FORMULAS_PATH}/env/_formulas/${formula_service}/${formula_service} /usr/share/salt-formulas/env/${formula_service}
551 [ ! -L "${RECLASS_ROOT}/classes/service/${formula_service}" ] && \
552 ln -sf ${FORMULAS_PATH}/env/_formulas/${formula_service}/metadata/service ${RECLASS_ROOT}/classes/service/${formula_service}
553 done
554
555 [ ! -d /srv/salt/env ] && mkdir -p /srv/salt/env || echo ""
556 [ ! -L /srv/salt/env/dev ] && ln -s /usr/share/salt-formulas/env /srv/salt/env/dev || echo ""
557}
558
559
560saltmaster_bootstrap() {
561
562 log_info "Salt master setup"
563 test -n "$MASTER_HOSTNAME" || exit 1
564
565 clone_reclass
566 # override some envs from cluster level *.env, use with care
567 source_local_envs
568
Petr Michalec7ed7d8f2017-10-10 15:38:29 +0200569 pgrep salt-master | sed /$$/d | xargs --no-run-if-empty -i{} $SUDO kill -9 {} || true
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200570 pkill -9 salt-minion
projoke3c30e7d2017-10-19 17:15:40 +0800571 SCRIPTS=$(dirname $0)
572
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200573 test -e ${SCRIPTS}/.salt-master-setup.sh.passed || {
Adam Tengler035f24f2017-09-11 19:29:31 +0200574 export MASTER_IP=${MASTER_IP:-127.0.0.1}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200575 export MINION_ID=${MASTER_HOSTNAME}
576 if ! [[ $DEBUG =~ ^(True|true|1|yes)$ ]]; then
577 SALT_MASTER_SETUP_OUTPUT='/dev/stdout'
578 fi
579 # call local "setup() master"
580 #if ! $SUDO ${SCRIPTS}/salt-master-setup.sh master &> ${SALT_MASTER_SETUP_OUTPUT:-/tmp/salt-master-setup.log}; then
581 if ! setup master; then
582 #cat /tmp/salt-master-setup.log
583 log_err "salt master setup() failed."
584 exit 1
585 else
586 $SUDO touch ${SCRIPTS}/.salt-master-setup.sh.passed
587 fi
588 }
589
Petr Michaleca6cd2bd2017-09-07 16:59:19 +0200590 if [[ $RECLASS_VERSION =~ ^(dev|devel|master)$ ]]; then
Petr Michalec2f9a35b2017-09-07 17:08:06 +0200591 log_warn "Install development version of reclass"
Petr Michaleca6cd2bd2017-09-07 16:59:19 +0200592 install_reclass ${RECLASS_VERSION/dev*/master}
593 fi
594
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200595 log_info "Re/starting salt services"
Petr Michalec7ed7d8f2017-10-10 15:38:29 +0200596 $SUDO service salt-minion stop
597 $SUDO service salt-master stop
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200598 sleep 10
Petr Michalec7ed7d8f2017-10-10 15:38:29 +0200599 pgrep salt-master | sed /$$/d | xargs --no-run-if-empty -i{} $SUDO kill -9 {} || true
600 pkill -9 salt-minion
601 $SUDO service salt-master start
602 $SUDO service salt-minion start
603 sleep 15
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200604}
605
606# Init salt master
607saltmaster_init() {
608
609 log_info "Runing saltmaster states"
610 test -n "$MASTER_HOSTNAME" || exit 1
611
612 set -e
613 $SUDO salt-call saltutil.sync_all >/dev/null
614
615 # TODO: Placeholder update saltmaster spec (nodes/FQDN.yml) to be able to bootstrap with minimal configuration
616 # (ie: with linux, git, salt formulas)
617
618 #log_info "Verify SaltMaster, before salt-master is fully initialized"
619 #if ! $SUDO reclass-salt -p ${MASTER_HOSTNAME} &> /tmp/${MASTER_HOSTNAME}.pillar;then
620 # log_warn "Node verification before initialization failed."; cat /tmp/${MASTER_HOSTNAME}.pillar;
621 #fi
622
Petr Michalecda014202017-08-18 11:26:07 +0200623 # workarond isolated and not fully bootstraped environments
Petr Michalec2801acb2017-10-31 15:00:15 +0100624 if [[ $RECLASS_IGNORE_CLASS_NOTFOUND =~ ^(True|true|1|yes)$ ]]; then
625 SALT_MASTER_PILLAR='"salt":{"master":{"pillar":{"reclass":{"ignore_class_notfound": "\'${RECLASS_IGNORE_CLASS_NOTFOUND:-False}\'", "ignore_class_regexp": ["service.*"]}}}},'
626 fi
627 PILLAR='{${SALT_MASTER_PILLAR} "reclass":{"storage":{"data_source":{"engine":"local"}}} }'
Petr Michalecda014202017-08-18 11:26:07 +0200628
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200629 log_info "State: salt.master.env"
Petr Michalecda014202017-08-18 11:26:07 +0200630 if ! $SUDO salt-call ${SALT_OPTS} -linfo state.apply salt.master.env pillar="$PILLAR"; then
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200631 log_err "State salt.master.env failed, keep your eyes wide open."
632 fi
633
634 log_info "State: salt.master.pillar"
Petr Michalecda014202017-08-18 11:26:07 +0200635 retry ${SALT_STATE_RETRY} $SUDO salt-call ${SALT_OPTS} state.apply salt.master.pillar pillar="$PILLAR"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200636 # Note: sikp reclass data dir states
637 # in order to avoid pull from configured repo/branch
638
639 # Revert temporary SaltMaster minimal configuration, if any
640 pushd $RECLASS_ROOT
641 if [ $(git diff --name-only nodes | sort | uniq | wc -l) -ge 1 ]; then
642 git status || true
Petr Michalecda014202017-08-18 11:26:07 +0200643 log_warn "Locally modified $RECLASS_ROOT/nodes found. (Possibly salt-master minimized setup from bootstrap.sh call)"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200644 log_info "Checkout HEAD state of $RECLASS_ROOT/nodes/*."
645 git checkout -- $RECLASS_ROOT/nodes || true
646 log_info "Re-Run states: salt.master.env and salt.master.pillar according the HEAD state."
647 log_info "State: salt.master.env"
Petr Michalecda014202017-08-18 11:26:07 +0200648 if ! $SUDO salt-call ${SALT_OPTS} -linfo state.apply salt.master.env pillar="$PILLAR"; then
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200649 log_err "State salt.master.env failed, keep your eyes wide open."
650 fi
651 log_info "State: salt.master.pillar"
Petr Michalecda014202017-08-18 11:26:07 +0200652 retry ${SALT_STATE_RETRY} $SUDO salt-call ${SALT_OPTS} state.apply salt.master.pillar pillar="$PILLAR"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200653 fi
654 popd
655
Petr Michalecda014202017-08-18 11:26:07 +0200656 # finally re-configure salt master conf, ie: may remove ignore_class_notfound option
657 log_info "State: salt.master.service"
Petr Michalec9fec8b32017-10-05 14:46:42 +0200658 retry ${SALT_STATE_RETRY} $SUDO salt-call ${SALT_OPTS} state.apply salt.master.service || true
Petr Michalecda014202017-08-18 11:26:07 +0200659
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200660 log_info "State: salt.master.storage.node"
661 set +e
Petr Michaleca5141342017-08-16 12:55:20 +0200662 # TODO: PLACEHOLDER TO TRIGGER NODE GENERATION THROUG SALT REACT.
Petr Michalec9fec8b32017-10-05 14:46:42 +0200663 retry ${SALT_STATE_RETRY} $SUDO salt-call ${SALT_OPTS} state.apply reclass.storage.node
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200664 ret=$?
665 set -e
666
667 if [[ $ret -eq 2 ]]; then
668 log_err "State reclass.storage.node failed with exit code 2 but continuing."
669 elif [[ $ret -ne 0 ]]; then
670 log_err "State reclass.storage.node failed with exit code $ret"
671 exit 1
672 fi
673
674 log_info "Re/starting salt services"
675 $SUDO sed -i 's/^master:.*/master: localhost/' /etc/salt/minion.d/minion.conf
Petr Michalecc0bfa972017-09-08 15:21:01 +0200676 $SUDO service salt-minion stop
677 $SUDO service salt-master stop
Petr Michalec7ed7d8f2017-10-10 15:38:29 +0200678 sleep 10
679 pgrep salt-master | sed /$$/d | xargs --no-run-if-empty -i{} $SUDO kill -9 {} || true
Petr Michalecc0bfa972017-09-08 15:21:01 +0200680 $SUDO service salt-master start
681 $SUDO service salt-minion start
Petr Michalec7ed7d8f2017-10-10 15:38:29 +0200682 sleep 15
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200683 $SUDO salt-call ${SALT_OPTS} saltutil.sync_all >/dev/null
684
685 verify_salt_master
686 set +e
687
688}
689
690
691function verify_salt_master() {
692 set -e
693
694 log_info "Verify Salt master"
695 test -n "$MASTER_HOSTNAME" || exit 1
696
697 if [[ $VERIFY_SALT_CALL =~ ^(True|true|1|yes)$ ]]; then
Petr Michaleca5141342017-08-16 12:55:20 +0200698 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} reclass.validate_yaml > /tmp/${MASTER_HOSTNAME}.reclass.validate_yaml
699 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} reclass.validate_pillar > /tmp/${MASTER_HOSTNAME}.reclass.validate_pillar
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200700 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} grains.item roles > /tmp/${MASTER_HOSTNAME}.grains.item.roles
701 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} state.show_lowstate > /tmp/${MASTER_HOSTNAME}.state.show_state
702 $SUDO salt-call --no-color grains.items
703 $SUDO salt-call --no-color pillar.data
704 fi
Petr Michaleca5141342017-08-16 12:55:20 +0200705 # TODO: REMOVE reclass --nodeinfo section / run only on debug - as the only required is reclass.validate_*
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200706 if ! $SUDO reclass --nodeinfo ${MASTER_HOSTNAME} > /tmp/${MASTER_HOSTNAME}.reclass.nodeinfo; then
707 log_err "For more details see full log /tmp/${MASTER_HOSTNAME}.reclass.nodeinfo"
708 exit 1
709 fi
710}
711
712function verify_salt_minion() {
713 set -e
714 node=$1
715 log_info "Verifying ${node}"
716 if [[ $VERIFY_SALT_CALL =~ ^(True|true|1|yes)$ ]]; then
717 $SUDO salt-call ${SALT_OPTS} --id=${node} grains.item roles > /tmp/${node}.grains.item.roles
718 $SUDO salt-call ${SALT_OPTS} --id=${node} state.show_lowstate > /tmp/${node}.state.show_lowstate
719 fi
720 if ! $SUDO reclass --nodeinfo ${node} > /tmp/${node}.reclass.nodeinfo; then
721 log_err "For more details see full log /tmp/${node}.reclass.nodeinfo"
722 if [[ ${BREAK_ON_VERIFICATION_ERROR:-yes} =~ ^(True|true|1|yes)$ ]]; then
723 exit 1
724 fi
725 fi
726}
727
728function verify_salt_minions() {
729 #set -e
Petr Michalec679f15b2017-09-18 16:16:29 +0200730 NODES=$(find $RECLASS_ROOT/nodes/_generated/ -name "*.yml" | grep -v "cfg")
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200731 log_info "Verifying minions: $(echo ${NODES}|xargs)"
732
733 # Parallel
734 #echo $NODES | parallel --no-notice -j 2 --halt 2 "verify_salt_minion \$(basename {} .yml) > {}.pillar_verify"
735 #ls -lrta *.pillar_verify | tail -n 1 | xargs -n1 tail -n30
736
737 function filterFails() {
738 grep -v '/grains' | tee -a $1 | tail -n20
739 }
740
741 log_info "Verify nodes"
742 passed=0
743 for node in ${NODES}; do
744 node=$(basename $node .yml)
745
746 # filter first in cluster.. ctl-01, mon-01, etc..
747 if [[ "${node//.*}" =~ 01 || "${node//.*}" =~ 02 ]] ;then
748 verify_salt_minion ${node} || continue
749 else
750 echo Skipped $node.
751 fi
752 passed=$(($passed+1))
753 done
754 # fail on failures
755 total=$(echo $NODES | xargs --no-run-if-empty -n1 echo |wc -l)
756 test ! $passed -lt $total || log_err "Results: $passed of $total passed."
757 test ! $passed -lt $total || {
758 tail -n50 /tmp/*.pillar_verify
759 return 1
760 }
761}
762
763
764
765##########################################
766# To install salt master/minon
767
768function install() {
769 setup $@
770}
771
772function setup() {
773 # CLI
774 while [ x"$1" != x"" ]; do
775 which curl &>/dev/null || $PKGTOOL -y install curl &>/dev/null
776
777 case $1 in
778 master )
779 install_salt_master_$SALT_SOURCE
780 install_salt_minion_$SALT_SOURCE
781 install_salt_formula_$FORMULAS_SOURCE
782 ;;
783 minion )
784 install_salt_minion_$SALT_SOURCE
785 ;;
786 esac
787 shift
788 done
789 echo DONE
790}
791
792function bootstrap() {
793 log_info "Bootstrap & verification of SaltMaster and configured minions."
794 trap _atexit INT TERM EXIT
795
796 system_config_master
797 saltmaster_bootstrap &&\
Petr Michalec58575b92017-08-20 10:42:25 +0200798 saltmaster_init #&&\
Petr Michaleca5141342017-08-16 12:55:20 +0200799 #verify_salt_minions
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200800}
801
802function default() {
803 bootstrap $@
804}
805
806
807##########################################
808[[ "$0" != "$BASH_SOURCE" ]] || {
809# unless file is being sourced
810 default $@
811}